package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsOrderCouponExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsOrderCouponExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIsNull() {
            addCriterion("child_order_no is null");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIsNotNull() {
            addCriterion("child_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoEqualTo(String value) {
            addCriterion("child_order_no =", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotEqualTo(String value) {
            addCriterion("child_order_no <>", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoGreaterThan(String value) {
            addCriterion("child_order_no >", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("child_order_no >=", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLessThan(String value) {
            addCriterion("child_order_no <", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLessThanOrEqualTo(String value) {
            addCriterion("child_order_no <=", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLike(String value) {
            addCriterion("child_order_no like", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotLike(String value) {
            addCriterion("child_order_no not like", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIn(List<String> values) {
            addCriterion("child_order_no in", values, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotIn(List<String> values) {
            addCriterion("child_order_no not in", values, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoBetween(String value1, String value2) {
            addCriterion("child_order_no between", value1, value2, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotBetween(String value1, String value2) {
            addCriterion("child_order_no not between", value1, value2, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeIsNull() {
            addCriterion("platform_code is null");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeIsNotNull() {
            addCriterion("platform_code is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeEqualTo(String value) {
            addCriterion("platform_code =", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeNotEqualTo(String value) {
            addCriterion("platform_code <>", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeGreaterThan(String value) {
            addCriterion("platform_code >", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeGreaterThanOrEqualTo(String value) {
            addCriterion("platform_code >=", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeLessThan(String value) {
            addCriterion("platform_code <", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeLessThanOrEqualTo(String value) {
            addCriterion("platform_code <=", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeLike(String value) {
            addCriterion("platform_code like", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeNotLike(String value) {
            addCriterion("platform_code not like", value, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeIn(List<String> values) {
            addCriterion("platform_code in", values, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeNotIn(List<String> values) {
            addCriterion("platform_code not in", values, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeBetween(String value1, String value2) {
            addCriterion("platform_code between", value1, value2, "platformCode");
            return (Criteria) this;
        }

        public Criteria andPlatformCodeNotBetween(String value1, String value2) {
            addCriterion("platform_code not between", value1, value2, "platformCode");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(Long value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(Long value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(Long value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(Long value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(Long value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<Long> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<Long> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(Long value1, Long value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(Long value1, Long value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNull() {
            addCriterion("user_phone is null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNotNull() {
            addCriterion("user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneEqualTo(String value) {
            addCriterion("user_phone =", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotEqualTo(String value) {
            addCriterion("user_phone <>", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThan(String value) {
            addCriterion("user_phone >", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("user_phone >=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThan(String value) {
            addCriterion("user_phone <", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("user_phone <=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLike(String value) {
            addCriterion("user_phone like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotLike(String value) {
            addCriterion("user_phone not like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIn(List<String> values) {
            addCriterion("user_phone in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotIn(List<String> values) {
            addCriterion("user_phone not in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneBetween(String value1, String value2) {
            addCriterion("user_phone between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotBetween(String value1, String value2) {
            addCriterion("user_phone not between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdIsNull() {
            addCriterion("goods_type_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdIsNotNull() {
            addCriterion("goods_type_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdEqualTo(Long value) {
            addCriterion("goods_type_id =", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdNotEqualTo(Long value) {
            addCriterion("goods_type_id <>", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdGreaterThan(Long value) {
            addCriterion("goods_type_id >", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_type_id >=", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdLessThan(Long value) {
            addCriterion("goods_type_id <", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_type_id <=", value, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdIn(List<Long> values) {
            addCriterion("goods_type_id in", values, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdNotIn(List<Long> values) {
            addCriterion("goods_type_id not in", values, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdBetween(Long value1, Long value2) {
            addCriterion("goods_type_id between", value1, value2, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_type_id not between", value1, value2, "goodsTypeId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameIsNull() {
            addCriterion("goods_type_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameIsNotNull() {
            addCriterion("goods_type_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameEqualTo(String value) {
            addCriterion("goods_type_name =", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameNotEqualTo(String value) {
            addCriterion("goods_type_name <>", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameGreaterThan(String value) {
            addCriterion("goods_type_name >", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_type_name >=", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameLessThan(String value) {
            addCriterion("goods_type_name <", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameLessThanOrEqualTo(String value) {
            addCriterion("goods_type_name <=", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameLike(String value) {
            addCriterion("goods_type_name like", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameNotLike(String value) {
            addCriterion("goods_type_name not like", value, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameIn(List<String> values) {
            addCriterion("goods_type_name in", values, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameNotIn(List<String> values) {
            addCriterion("goods_type_name not in", values, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameBetween(String value1, String value2) {
            addCriterion("goods_type_name between", value1, value2, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNameNotBetween(String value1, String value2) {
            addCriterion("goods_type_name not between", value1, value2, "goodsTypeName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdIsNull() {
            addCriterion("goods_brand_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdIsNotNull() {
            addCriterion("goods_brand_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdEqualTo(Long value) {
            addCriterion("goods_brand_id =", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdNotEqualTo(Long value) {
            addCriterion("goods_brand_id <>", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdGreaterThan(Long value) {
            addCriterion("goods_brand_id >", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_brand_id >=", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdLessThan(Long value) {
            addCriterion("goods_brand_id <", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_brand_id <=", value, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdIn(List<Long> values) {
            addCriterion("goods_brand_id in", values, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdNotIn(List<Long> values) {
            addCriterion("goods_brand_id not in", values, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdBetween(Long value1, Long value2) {
            addCriterion("goods_brand_id between", value1, value2, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_brand_id not between", value1, value2, "goodsBrandId");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameIsNull() {
            addCriterion("goods_brand_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameIsNotNull() {
            addCriterion("goods_brand_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameEqualTo(String value) {
            addCriterion("goods_brand_name =", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameNotEqualTo(String value) {
            addCriterion("goods_brand_name <>", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameGreaterThan(String value) {
            addCriterion("goods_brand_name >", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_brand_name >=", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameLessThan(String value) {
            addCriterion("goods_brand_name <", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameLessThanOrEqualTo(String value) {
            addCriterion("goods_brand_name <=", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameLike(String value) {
            addCriterion("goods_brand_name like", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameNotLike(String value) {
            addCriterion("goods_brand_name not like", value, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameIn(List<String> values) {
            addCriterion("goods_brand_name in", values, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameNotIn(List<String> values) {
            addCriterion("goods_brand_name not in", values, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameBetween(String value1, String value2) {
            addCriterion("goods_brand_name between", value1, value2, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsBrandNameNotBetween(String value1, String value2) {
            addCriterion("goods_brand_name not between", value1, value2, "goodsBrandName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdIsNull() {
            addCriterion("goods_specs_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdIsNotNull() {
            addCriterion("goods_specs_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdEqualTo(Long value) {
            addCriterion("goods_specs_id =", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdNotEqualTo(Long value) {
            addCriterion("goods_specs_id <>", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdGreaterThan(Long value) {
            addCriterion("goods_specs_id >", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_specs_id >=", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdLessThan(Long value) {
            addCriterion("goods_specs_id <", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_specs_id <=", value, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdIn(List<Long> values) {
            addCriterion("goods_specs_id in", values, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdNotIn(List<Long> values) {
            addCriterion("goods_specs_id not in", values, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdBetween(Long value1, Long value2) {
            addCriterion("goods_specs_id between", value1, value2, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_specs_id not between", value1, value2, "goodsSpecsId");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameIsNull() {
            addCriterion("goods_specs_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameIsNotNull() {
            addCriterion("goods_specs_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameEqualTo(String value) {
            addCriterion("goods_specs_name =", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameNotEqualTo(String value) {
            addCriterion("goods_specs_name <>", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameGreaterThan(String value) {
            addCriterion("goods_specs_name >", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_specs_name >=", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameLessThan(String value) {
            addCriterion("goods_specs_name <", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_specs_name <=", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameLike(String value) {
            addCriterion("goods_specs_name like", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameNotLike(String value) {
            addCriterion("goods_specs_name not like", value, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameIn(List<String> values) {
            addCriterion("goods_specs_name in", values, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameNotIn(List<String> values) {
            addCriterion("goods_specs_name not in", values, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameBetween(String value1, String value2) {
            addCriterion("goods_specs_name between", value1, value2, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecsNameNotBetween(String value1, String value2) {
            addCriterion("goods_specs_name not between", value1, value2, "goodsSpecsName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceIsNull() {
            addCriterion("goods_spesc_original_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceIsNotNull() {
            addCriterion("goods_spesc_original_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_original_price =", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_original_price <>", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceGreaterThan(BigDecimal value) {
            addCriterion("goods_spesc_original_price >", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_original_price >=", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceLessThan(BigDecimal value) {
            addCriterion("goods_spesc_original_price <", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_original_price <=", value, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceIn(List<BigDecimal> values) {
            addCriterion("goods_spesc_original_price in", values, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_spesc_original_price not in", values, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_spesc_original_price between", value1, value2, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescOriginalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_spesc_original_price not between", value1, value2, "goodsSpescOriginalPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceIsNull() {
            addCriterion("goods_spesc_sale_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceIsNotNull() {
            addCriterion("goods_spesc_sale_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_sale_price =", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_sale_price <>", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceGreaterThan(BigDecimal value) {
            addCriterion("goods_spesc_sale_price >", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_sale_price >=", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceLessThan(BigDecimal value) {
            addCriterion("goods_spesc_sale_price <", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_spesc_sale_price <=", value, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceIn(List<BigDecimal> values) {
            addCriterion("goods_spesc_sale_price in", values, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_spesc_sale_price not in", values, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_spesc_sale_price between", value1, value2, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsSpescSalePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_spesc_sale_price not between", value1, value2, "goodsSpescSalePrice");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdIsNull() {
            addCriterion("goods_vpd_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdIsNotNull() {
            addCriterion("goods_vpd_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdEqualTo(Long value) {
            addCriterion("goods_vpd_id =", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdNotEqualTo(Long value) {
            addCriterion("goods_vpd_id <>", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdGreaterThan(Long value) {
            addCriterion("goods_vpd_id >", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_vpd_id >=", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdLessThan(Long value) {
            addCriterion("goods_vpd_id <", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_vpd_id <=", value, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdIn(List<Long> values) {
            addCriterion("goods_vpd_id in", values, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdNotIn(List<Long> values) {
            addCriterion("goods_vpd_id not in", values, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdBetween(Long value1, Long value2) {
            addCriterion("goods_vpd_id between", value1, value2, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_vpd_id not between", value1, value2, "goodsVpdId");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyIsNull() {
            addCriterion("goods_vpd_key is null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyIsNotNull() {
            addCriterion("goods_vpd_key is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyEqualTo(String value) {
            addCriterion("goods_vpd_key =", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyNotEqualTo(String value) {
            addCriterion("goods_vpd_key <>", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyGreaterThan(String value) {
            addCriterion("goods_vpd_key >", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyGreaterThanOrEqualTo(String value) {
            addCriterion("goods_vpd_key >=", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyLessThan(String value) {
            addCriterion("goods_vpd_key <", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyLessThanOrEqualTo(String value) {
            addCriterion("goods_vpd_key <=", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyLike(String value) {
            addCriterion("goods_vpd_key like", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyNotLike(String value) {
            addCriterion("goods_vpd_key not like", value, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyIn(List<String> values) {
            addCriterion("goods_vpd_key in", values, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyNotIn(List<String> values) {
            addCriterion("goods_vpd_key not in", values, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyBetween(String value1, String value2) {
            addCriterion("goods_vpd_key between", value1, value2, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdKeyNotBetween(String value1, String value2) {
            addCriterion("goods_vpd_key not between", value1, value2, "goodsVpdKey");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceIsNull() {
            addCriterion("goods_vpd_source is null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceIsNotNull() {
            addCriterion("goods_vpd_source is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceEqualTo(Integer value) {
            addCriterion("goods_vpd_source =", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceNotEqualTo(Integer value) {
            addCriterion("goods_vpd_source <>", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceGreaterThan(Integer value) {
            addCriterion("goods_vpd_source >", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_vpd_source >=", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceLessThan(Integer value) {
            addCriterion("goods_vpd_source <", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceLessThanOrEqualTo(Integer value) {
            addCriterion("goods_vpd_source <=", value, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceIn(List<Integer> values) {
            addCriterion("goods_vpd_source in", values, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceNotIn(List<Integer> values) {
            addCriterion("goods_vpd_source not in", values, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceBetween(Integer value1, Integer value2) {
            addCriterion("goods_vpd_source between", value1, value2, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsVpdSourceNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_vpd_source not between", value1, value2, "goodsVpdSource");
            return (Criteria) this;
        }

        public Criteria andGoodsCountIsNull() {
            addCriterion("goods_count is null");
            return (Criteria) this;
        }

        public Criteria andGoodsCountIsNotNull() {
            addCriterion("goods_count is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsCountEqualTo(Integer value) {
            addCriterion("goods_count =", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountNotEqualTo(Integer value) {
            addCriterion("goods_count <>", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountGreaterThan(Integer value) {
            addCriterion("goods_count >", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_count >=", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountLessThan(Integer value) {
            addCriterion("goods_count <", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountLessThanOrEqualTo(Integer value) {
            addCriterion("goods_count <=", value, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountIn(List<Integer> values) {
            addCriterion("goods_count in", values, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountNotIn(List<Integer> values) {
            addCriterion("goods_count not in", values, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountBetween(Integer value1, Integer value2) {
            addCriterion("goods_count between", value1, value2, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andGoodsCountNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_count not between", value1, value2, "goodsCount");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNull() {
            addCriterion("total_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNotNull() {
            addCriterion("total_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceEqualTo(BigDecimal value) {
            addCriterion("total_price =", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_price <>", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("total_price >", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price >=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThan(BigDecimal value) {
            addCriterion("total_price <", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price <=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIn(List<BigDecimal> values) {
            addCriterion("total_price in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_price not in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price not between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNull() {
            addCriterion("total_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNotNull() {
            addCriterion("total_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price =", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <>", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("total_deduction_price >", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price >=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThan(BigDecimal value) {
            addCriterion("total_deduction_price <", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price not in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price not between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNull() {
            addCriterion("coupon_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNotNull() {
            addCriterion("coupon_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price =", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <>", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("coupon_discount_price >", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price >=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThan(BigDecimal value) {
            addCriterion("coupon_discount_price <", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price not in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price not between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNull() {
            addCriterion("integral_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNotNull() {
            addCriterion("integral_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceEqualTo(Long value) {
            addCriterion("integral_discount_price =", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotEqualTo(Long value) {
            addCriterion("integral_discount_price <>", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThan(Long value) {
            addCriterion("integral_discount_price >", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price >=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThan(Long value) {
            addCriterion("integral_discount_price <", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price <=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIn(List<Long> values) {
            addCriterion("integral_discount_price in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotIn(List<Long> values) {
            addCriterion("integral_discount_price not in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price not between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNull() {
            addCriterion("pay_real_price is null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNotNull() {
            addCriterion("pay_real_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceEqualTo(BigDecimal value) {
            addCriterion("pay_real_price =", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <>", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_real_price >", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price >=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThan(BigDecimal value) {
            addCriterion("pay_real_price <", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIn(List<BigDecimal> values) {
            addCriterion("pay_real_price in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_real_price not in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price not between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayChannelIsNull() {
            addCriterion("pay_channel is null");
            return (Criteria) this;
        }

        public Criteria andPayChannelIsNotNull() {
            addCriterion("pay_channel is not null");
            return (Criteria) this;
        }

        public Criteria andPayChannelEqualTo(Integer value) {
            addCriterion("pay_channel =", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotEqualTo(Integer value) {
            addCriterion("pay_channel <>", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelGreaterThan(Integer value) {
            addCriterion("pay_channel >", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_channel >=", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelLessThan(Integer value) {
            addCriterion("pay_channel <", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelLessThanOrEqualTo(Integer value) {
            addCriterion("pay_channel <=", value, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelIn(List<Integer> values) {
            addCriterion("pay_channel in", values, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotIn(List<Integer> values) {
            addCriterion("pay_channel not in", values, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelBetween(Integer value1, Integer value2) {
            addCriterion("pay_channel between", value1, value2, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPayChannelNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_channel not between", value1, value2, "payChannel");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNull() {
            addCriterion("pay_serial_no is null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNotNull() {
            addCriterion("pay_serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoEqualTo(String value) {
            addCriterion("pay_serial_no =", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotEqualTo(String value) {
            addCriterion("pay_serial_no <>", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThan(String value) {
            addCriterion("pay_serial_no >", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_serial_no >=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThan(String value) {
            addCriterion("pay_serial_no <", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThanOrEqualTo(String value) {
            addCriterion("pay_serial_no <=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLike(String value) {
            addCriterion("pay_serial_no like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotLike(String value) {
            addCriterion("pay_serial_no not like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIn(List<String> values) {
            addCriterion("pay_serial_no in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotIn(List<String> values) {
            addCriterion("pay_serial_no not in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoBetween(String value1, String value2) {
            addCriterion("pay_serial_no between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotBetween(String value1, String value2) {
            addCriterion("pay_serial_no not between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNull() {
            addCriterion("pay_type is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNotNull() {
            addCriterion("pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeEqualTo(Integer value) {
            addCriterion("pay_type =", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotEqualTo(Integer value) {
            addCriterion("pay_type <>", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThan(Integer value) {
            addCriterion("pay_type >", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_type >=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThan(Integer value) {
            addCriterion("pay_type <", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThanOrEqualTo(Integer value) {
            addCriterion("pay_type <=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeIn(List<Integer> values) {
            addCriterion("pay_type in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotIn(List<Integer> values) {
            addCriterion("pay_type not in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeBetween(Integer value1, Integer value2) {
            addCriterion("pay_type between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_type not between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNull() {
            addCriterion("pay_time is null");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNotNull() {
            addCriterion("pay_time is not null");
            return (Criteria) this;
        }

        public Criteria andPayTimeEqualTo(Date value) {
            addCriterion("pay_time =", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotEqualTo(Date value) {
            addCriterion("pay_time <>", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThan(Date value) {
            addCriterion("pay_time >", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("pay_time >=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThan(Date value) {
            addCriterion("pay_time <", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThanOrEqualTo(Date value) {
            addCriterion("pay_time <=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeIn(List<Date> values) {
            addCriterion("pay_time in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotIn(List<Date> values) {
            addCriterion("pay_time not in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeBetween(Date value1, Date value2) {
            addCriterion("pay_time between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotBetween(Date value1, Date value2) {
            addCriterion("pay_time not between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNull() {
            addCriterion("cancel_time is null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNotNull() {
            addCriterion("cancel_time is not null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeEqualTo(Date value) {
            addCriterion("cancel_time =", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotEqualTo(Date value) {
            addCriterion("cancel_time <>", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThan(Date value) {
            addCriterion("cancel_time >", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("cancel_time >=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThan(Date value) {
            addCriterion("cancel_time <", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThanOrEqualTo(Date value) {
            addCriterion("cancel_time <=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIn(List<Date> values) {
            addCriterion("cancel_time in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotIn(List<Date> values) {
            addCriterion("cancel_time not in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeBetween(Date value1, Date value2) {
            addCriterion("cancel_time between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotBetween(Date value1, Date value2) {
            addCriterion("cancel_time not between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNull() {
            addCriterion("refund_time is null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNotNull() {
            addCriterion("refund_time is not null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeEqualTo(Date value) {
            addCriterion("refund_time =", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotEqualTo(Date value) {
            addCriterion("refund_time <>", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThan(Date value) {
            addCriterion("refund_time >", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("refund_time >=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThan(Date value) {
            addCriterion("refund_time <", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThanOrEqualTo(Date value) {
            addCriterion("refund_time <=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIn(List<Date> values) {
            addCriterion("refund_time in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotIn(List<Date> values) {
            addCriterion("refund_time not in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeBetween(Date value1, Date value2) {
            addCriterion("refund_time between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotBetween(Date value1, Date value2) {
            addCriterion("refund_time not between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}